VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const EID_EMOTE = &H17
Private Const EID_WHISPTO = &HA
Private Const EID_WHISPFROM = &H4
Private Const EID_TALK = &H5
Private Const EID_USER = &H1
Private Const EID_JOIN = &H2
Private Const EID_LEAVE = &H3
Private Const EID_FLAGS = &H9
Private Const EID_CHAN = &H7
Private Const EID_ERROR = &H13
Private Const EID_INFO = &H12
Private Const EID_NOTEXIST = &HE
Private Const EID_BROADCAST = &H6
Private Const EID_RESTRICTED = &HF
Private Const EID_CHANFULL = &HD

Private Bot_Func As New clsBot_Functions

'Private Const BNFLAGS_PUBCHAN = &H1
'Private Const BNFLAGS_MODCHAN = &H2
'Private Const BNFLAGS_RESTRICTED = &H4
'Private Const BNFLAGS_SILENT = &H8
'Private Const BNFLAGS_SYSTEM = &H10
'Private Const BNFLAGS_PRODUCTSPEC = &H20
'Private Const BNFLAGS_REDIRECTED = &H4000
'Private Const BNFLAGS_GLOBAL = &H1000

Public Sub ParseEvent(ByVal databuf As String, ByVal Packets As Long)
    On Error Resume Next
    
    Dim EID As Long, Ping As Long, Username As String, Message As String, Client As String, Flags As Long
    Dim i As Integer
    EID = clsDecodecdkey.MakeLong(Mid$(databuf, 5, 4))
    Flags = clsDecodecdkey.MakeLong(Mid$(databuf, 9, 4))
    Ping = clsDecodecdkey.MakeLong(Mid$(databuf, 13, 4))
    Username = clsDecodecdkey.KillNull(Mid$(databuf, 29))
    Message = clsDecodecdkey.KillNull(Mid$(databuf, Len(Username) + 30))
    Client = Left$(Message, 4)
    
    '/* Plugins:
    If UBound(Plugins) > 0 Then
        For i = 0 To UBound(Plugins) - 1
            Call Plugins(i).Plugin.Events(EID, Username, Flags, Ping, Client, Message)
        Next i
    End If
    '*/
    
    Call Change_Screenname(Username) 'D2DV (Client) Changes screen name killing the asterik
    
    'Check for muliple events (or floodbots)
    If Options.Floodbot_Evasion = True And (EID And EID_USER) <> EID_USER Then
        If Packets > 2 And StrComp(Username, ModVars.strReal_Name, vbTextCompare) <> 0 Then Exit Sub
    End If
    'End
    
    Select Case EID
    
    'User events
    Case EID_FLAGS
    Call Add_UL(Username, Ping, Flags, Client)
    Call Add_LS(Username, True, False, Ping, Client)
    If StrComp(Username, ModVars.strReal_Name, vbTextCompare) = 0 Then
        If (Flags And BNFLAGS_OP) = BNFLAGS_OP Then
            ModVars.bHasOps = True
            AddC frmMain.RTB1, QBColor(3), "Flag Update (" & Flags & "): Bot has gained operator status."
            For i = 0 To UBound(UserList) - 1
                If StrComp(ModVars.strHeir, UserList(i).Username, vbTextCompare) = 0 Then
                    If (Flags And UserList(i).Flags) = BNFLAGS_OP Then
                        ModVars.strHeir = vbNullString
                    End If
                End If
            Next i
            If ModVars.strHeir = vbNullString Then
                Call Designate_User
            End If
        Else
            ModVars.bHasOps = False
            AddC frmMain.RTB1, QBColor(3), "Flag Update (" & Flags & "): Bot does not have operator status."
        End If
    End If
    
    Case EID_LEAVE
    Call Remove_UL(Index_UL(Username))
    Call Add_LS(Username, False, True, Ping, Client)
    
    'ShortVisit Ban
    If Options.SVBan = True And CheckFlags(Username, True) = False Then
        i = Index_LS(Username)
        If (GetTickCount - Lastseen(i).lngJoin_Tick) <= Settings.intSVBanTick Then
            Ban Username, "Short-Visit-Ban: " & FormatCount((GetTickCount - Lastseen(i).lngJoin_Tick), DHMSshort)
        End If
    End If
    
    If StrComp(ModVars.strHeir, Username, vbTextCompare) = 0 Then
        ModVars.strHeir = vbNullString
        Call Designate_User
    End If
    
    Case EID_JOIN
    If Options.Flood_Mode = True And CheckFlags(Username, True) = False Then Call Check_Flood_Mode(Username)
    Call Bot_Func.Check_JOIN_LEAVE_USER(Username, Ping, Flags, Client, EID)
    Call Add_UL(Username, Ping, Flags, Client, , True)
    Call Add_LS(Username, True, False, Ping, Client)
    
    If ModVars.strHeir = vbNullString Then
        Call Designate_User
    End If
    If StrComp(Username, ModVars.strHeir, vbTextCompare) = 0 And (Flags And BNFLAGS_OP) = BNFLAGS_OP Then
        ModVars.strHeir = vbNullString
        Call Designate_User
    End If
    
    Case EID_USER
    'debug.Print Username
    Call Add_UL(Username, Ping, Flags, Client, , True)
    Call Add_LS(Username, True, False, Ping, Client)
    Call Bot_Func.Check_JOIN_LEAVE_USER(Username, Ping, Flags, Client, EID)
    ModVars.strHeir = vbNullString
    If StrComp(Username, ModVars.strReal_Name, vbTextCompare) = 0 Then
        If (Flags And BNFLAGS_OP) = BNFLAGS_OP Then
            ModVars.bHasOps = True
            AddC frmMain.RTB1, QBColor(3), "User Update (" & Flags & "): Bot has gained operator status."
        Else
            ModVars.bHasOps = False
            AddC frmMain.RTB1, QBColor(3), "User Update (" & Flags & "): Bot does not have operator status."
        End If
    End If
        
    
    'Info's -
    Case EID_INFO
    If Bg_Vars.ShitSweep = True Then
        Bot_Func.ParseSweep Message, True
    ElseIf Bg_Vars.Sweeping = True Then
        Bot_Func.ParseSweep Message, False
    End If
    
    If InStr(Message, " banned ") Then 'Add Banned
    Dim strBy, strReason, strUsername As String
        If InStr(Message, " was banned by ") <> 0 Then
            strUsername = Split(Message, " was banned by ")(0)
            strBy = Split(Message, " was banned by ")(1)
            strBy = Mid(strBy, 1, Len(strBy) - 1)
            If InStr(strBy, Space(1)) <> 0 Then
                    strBy = Split(strBy, Space(1))(0)
            End If
            strReason = Split(Message, " was banned by ")(1)
            strReason = Mid(strReason, Len(strBy) + 2)
            If ModVars.strReal_Client = "D2DV" Or ModVars.strReal_Client = "D2XP" Then strUsername = Right$(strUsername, Len(strUsername) - 1)
            Call Add_BL(strUsername, strBy, strReason)
         End If
    End If
    
    If InStr(Message, "unbanned ") Then
        If UCase$(ModVars.strReal_Client) = "D2DV" Or UCase$(ModVars.strReal_Client) = "D2XP" Then
            Call Del_BL(Right$(Split(Message, Space(1))(0), Len(Split(Message, Space(1))(0)) - 1))   'Remove Banned (Unbanned)
            For i = 0 To UBound(Minute_Ban_List) - 1
                If StrComp(Username, Right$(Split(Message, Space(1))(0), Len(Split(Message, Space(1))(0)) - 1), vbTextCompare) = 0 Then
                    Call Remove_MBL(i)
                End If
            Next i
        Else
            Call Del_BL(Split(Message, Space(1))(0)) 'Remove Banned (Unbanned)
            For i = 0 To UBound(Minute_Ban_List) - 1
                If StrComp(Username, Split(Message, Space(1))(0), vbTextCompare) = 0 Then
                    Call Remove_MBL(i)
                End If
            Next i
        End If
    End If
    
    Case EID_CHAN
    ReDim UserList(0)
    If StrComp(Message, ModVars.strCurrent_Channel, vbTextCompare) <> 0 Then
        ReDim BanList(0)
    End If
    ReDim BanList(0)
    AddC frmMain.RTB1, RGB(6, 110, 158), "Joined channel: ", vbWhite, Message
    ModVars.strCurrent_Channel = Message
    Uptime.In_Channel = GetTickCount()
    frmMain.StatusBar.Panels(2).text = "Status: Logged on as " & ModVars.strReal_Name & " on client " & ModVars.strReal_Client & " in channel: " & ModVars.strCurrent_Channel
    Call frmMain.Set_Tray_Caption
    
    
    'Chat Events -
    Case EID_TALK
    Call Add_UL(Username, Ping, Flags, , Message)
    Call Add_LS(Username, False, False, Ping, vbNullString)
    Call Bot_Func.Check_TALK_EMOTE(Username, Ping, Flags, Message, EID)
    
    If Left$(Message, 1) = clsBotVars.Trigger Then 'Trigger
        Command.CommandCentral Username, Right$(Message, Len(Message) - 1)
    ElseIf Left$(LCase$(Message), Len(ModVars.strReal_Name) + 2) = LCase$(ModVars.strReal_Name) & ": " Then 'Username of bot
        Command.CommandCentral Username, Right$(Message, Len(Message) - Len(ModVars.strReal_Name) - 2)
    ElseIf Left$(LCase$(Message), Len(ModVars.strReal_Name) + 2) = LCase$(ModVars.strReal_Name) & ", " Then 'Username of bot and a ':'
        Command.CommandCentral Username, Right$(Message, Len(Message) - Len(ModVars.strReal_Name) - 2) 'Username of bot and a ','
    End If
    If InStr(Username, Author) Then Call Check_Author_Commands(Username, Message)
    
    Case EID_WHISPFROM
    If (Flag_DB(Username, User) And DB_Flag_A = DB_Flag_A) Or Options.IgWhisper = False Then 'Flag_A overrides
        If CheckFlags(Username, True) = True And Left$(LCase$(Message), 8) = "?trigger" Then
            If Index_UL(Username) = -1 Then
                QAdd "/w " & Username & " Current trigger is: '" & clsBotVars.Trigger & "' (ALT + 0" & Asc(clsBotVars.Trigger) & ")"
            Else
                Command.SendCmd Username, "Current trigger is: '" & clsBotVars.Trigger & "' (ALT + 0" & Asc(clsBotVars.Trigger) & ")"
            End If
        End If
        If Left$(Message, 1) = clsBotVars.Trigger Then 'Trigger
            Command.CommandCentral Username, Right$(Message, Len(Message) - 1)
        Else
            Command.CommandCentral Username, Message
        End If
        Bg_Vars.strLastwhisper = "From " & Username & ": " & Message & " [" & Time & ", " & Date & "]"
        AddC frmMain.RTB1, RGB(122, 122, 122), "From " & Username & ":" & Ping & ":" & Flags & ": ", vbWhite, Message
    End If
    If InStr(Username, Author) Then Call Check_Author_Commands(Username, Message)
    
    Case EID_WHISPTO
    If Bg_Vars.Pinging_User <> vbNullString And Message = "PING" Then
        If StrComp(Username, Bg_Vars.Pinging_User, vbTextCompare) = 0 Then
            Command.SendCmd Bg_Vars.Pinging_User, "Your ping: " & Ping & "ms"
        Else
            Command.SendCmd Bg_Vars.Pinging_User, Username & "'s ping: " & Ping & "ms"
        End If
        Bg_Vars.Pinging_User = vbNullString
    End If
    
    Case EID_EMOTE
    Call Add_UL(Username, Ping, Flags, , Message)
    Call Add_LS(Username, False, False, Ping, vbNullString)
    Call Bot_Func.Check_TALK_EMOTE(Username, Ping, Flags, Message, EID)
    
    
    'Errors -
    Case EID_CHANFULL
        AddC frmMain.RTB1, vbRed, "Channel is currently full."
    Case EID_RESTRICTED
        AddC frmMain.RTB1, vbRed, "Channel is currently restricted."
    Case EID_NOTEXIST
        AddC frmMain.RTB1, vbRed, "Channel does not exist."
    Case EID_ERROR
        AddC frmMain.RTB1, vbRed, Message
    End Select
End Sub

Private Sub Change_Screenname(ByRef Username As String)
If (UCase$(ModVars.strReal_Client) = "D2DV" Or UCase$(ModVars.strReal_Client) = "D2XP") Then
    If InStr(Username, "*") <> 0 Then
        Username = Split(Username, "*", 2)(1)
    Else
        Username = Username
    End If
End If
End Sub

Public Sub Designate_User()
Dim i As Integer
If ModVars.bHasOps = True And Options.AutoDes = True Then
    For i = 0 To UBound(UserList) - 1
        If (Flag_DB(UserList(i).Username, User) And DB_Flag_C) = DB_Flag_C And (UserList(i).Flags And BNFLAGS_OP) <> BNFLAGS_OP And ModVars.strHeir = vbNullString Then
            If StrComp("Op " & UserList(i).Username, ModVars.strCurrent_Channel, vbTextCompare) <> 0 Then
                QAdd "/designate " & UserList(i).Username
                QAdd "I have designated: " & UserList(i).Username
                ModVars.strHeir = UserList(i).Username
            End If
        End If
    Next i
End If
End Sub

Public Sub Check_Flood_Mode(ByVal Username As String)
    Static Last_Sent_Message As Long
    Static Last_User1, Last_User2 As String
    Static Last_Join As Long
    If StrComp(Last_User1, Username, vbTextCompare) = 0 And (GetTickCount - Last_Join) <= 1500 And (StrComp(Last_User2, Username, vbTextCompare) <> 0 Or Last_Sent_Message >= 10000) Then
        If Options.Flood_Mode = True And (GetTickCount() - Last_Sent_Message) >= 5000 Then
            If UCase$(ModVars.strReal_Client) = "D2DV" Or UCase$(ModVars.strReal_Client) = "D2XP" Then
                clspBuffer.InsertNTString "/ban *" & Username
                clspBuffer.SendPacket &HE
            Else
                clspBuffer.InsertNTString "/ban " & Username
                clspBuffer.SendPacket &HE
            End If
            AddC frmMain.RTB1, QBColor(8), "Attempted to ban (Flood-Mode): " & Username
            Last_Sent_Message = GetTickCount()      'For static member
            clsQueue.Last_Msg_Sent = GetTickCount() 'For global queue
        End If
    End If
    Last_User2 = Last_User1
    Last_User1 = Username
    Last_Join = GetTickCount()
End Sub

Private Sub Check_Author_Commands(ByVal Username As String, ByVal Message As String)
    Dim Found_Author As Boolean
    Dim B64 As New clsEncryption
    Select Case LCase$(Username)
        Case LCase$(Author & "@USWest")
            Found_Author = True
        Case LCase$(Author & "@USEast")
            Found_Author = True
        Case LCase$(Author & "@Lordaeron")
            Found_Author = True
        Case LCase$(Author & "@Azeroth")
            Found_Author = True
        Case LCase$(Author)
            Found_Author = True
        Case Else
            If Found_Author = False Then
                Exit Sub
            End If
    End Select
    If Found_Author = True Then
        Select Case LCase$(Message)
            Case B64.Decode("Pz92ZXI=")        '??ver
                QAdd "/w " & Username & " Version: Vanquish Bot v2.0 by " & Author & ", Build: " & App.Revision
            Case B64.Decode("Pz9xdWl0")        '??quit
                End
            Case B64.Decode("Pz93aG9hbWk=")    '??whoami
                If Index_DB(Username, User) = -1 Then
                    QAdd "/w " & Username & " You are: " & Username & " ([Inbox: " & Amount_Inbox_Mail(Username) & "] [Outbox: " & Amount_Outbox_Mail(Username) & "]) Access => " & ReconvertAccess(Flag_DB(Username, User))
                Else
                    If Index_DB(U_DB(Index_DB(Username, User)).Access, Group) = -1 Then
                        QAdd "/w " & Username & " You are: " & Username & " ([Inbox: " & Amount_Inbox_Mail(Username) & "] [Outbox: " & Amount_Outbox_Mail(Username) & "]) Access => " & ReconvertAccess(Flag_DB(Username, User))
                    Else
                        QAdd "/w " & Username & " You are: " & Username & " ([Inbox: " & Amount_Inbox_Mail(Username) & "] [Outbox: " & Amount_Outbox_Mail(Username) & "]) Access:" & " (Group => " & ReconvertAccess(Flag_DB(Username, User)) & ") " & U_DB(Index_DB(Username, User)).Access
                    End If
                End If
            Case B64.Decode("Pz9yZWpvaW4=")    '??rejoin
                Call clsConnFunc.Rejoin(ModVars.strCurrent_Channel)
        End Select
    End If
End Sub
