VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLoad"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private LoadTime    As Long

Public Sub Load_All()
'On Error Resume Next
LoadTime = GetTickCount()
Call Rest_Arrays
Call Load_Configs
Call Load_CDKeys
Call Load_VerByte
Call Load_Settings
Call Load_Options
Call Load_Custom_Messages
Call Load_Quotes
Call Load_Phrases
Call Command.Load_Aliases
Call Reset_DB(True, True)
Call clsPlugins.Load_Plugins
Call Load_Timers
Call CalculateLoadTime
End Sub

Private Sub CalculateLoadTime()
    AddC frmMain.RTB2, RGB(6, 110, 158), "Elasped loading time: ", QBColor(7), FormatCount(GetTickCount - LoadTime, All2)
End Sub

Private Sub Rest_Arrays()
Call Reset_UL
ReDim BanList(0)
ReDim BotMail(0)
ReDim Lastseen(0)
ReDim Phrases(0)
ReDim Minute_Ban_List(0)
clsQueue.ResetQueue
End Sub

Private Sub Load_Timers()
    TMR_MINUTEBAN       'Check minuteban users
    TMR_KEEPALIVE       'Send 0x00 to battle.net to keep the connection alive
    TMR_QUEUE           'Begins queue timer to check queue
    TMR_MEMORYUSAGE     'Displays memory usage in statusbar
    TMR_AUTHORCHECK     'Protection Scheme
End Sub

Private Sub Load_Configs()
On Error Resume Next
clsBotVars.Server = ReadINI("Main", "Server", "Config.ini")
clsBotVars.Product = ReadINI("Main", "Product", "Config.ini")
clsBotVars.Username = ReadINI("Main", "Username", "Config.ini")
clsBotVars.cdkey = ReadINI("Main", "CDKey", "Config.ini")
clsBotVars.Channel = ReadINI("Main", "Home", "Config.ini")
clsBotVars.Password = ReadINI("Main", "Password", "Config.ini")
clsBotVars.BNLS_Use = ReadINI("BNLS", "Use", "Config.ini")
clsBotVars.Trigger = ReadINI("Main", "Trigger", "Config.ini")
clsBotVars.Spoof = ReadINI("Main", "Spoof", "Config.ini")
clsBotVars.Plug = ReadINI("Main", "Plug", "Config.ini")

clsBotVars.Email = ReadINI("Main", "Email", "Config.ini")

Proxy.Proxy_IP = ReadINI("PROXY", "ProxyIP/Port", "Config.ini")
Proxy.Proxy_Use = ReadINI("PROXY", "Use", "Config.ini")

If Asc(clsBotVars.Trigger) = 47 Or clsBotVars.Trigger = vbNullString Then
    clsBotVars.Trigger = "."
    AddC frmMain.RTB2, vbRed, "Error: Trigger was set to: '" & clsBotVars.Trigger & "' (ALT + 0" & Asc(clsBotVars.Trigger) & ")"
End If

clsBotVars.BNLS_Server = ReadINI("BNLS", "Server", "Config.ini")

clsBotVars.ODB_Path = ReadINI("Main", "DB_Path", "Config.ini")
If InStr(clsBotVars.ODB_Path, "%dir") Then
    clsBotVars.NDB_Path = Replace(clsBotVars.ODB_Path, "%dir", App.Path)
End If
If clsBotVars.NDB_Path = vbNullString Then
    clsBotVars.NDB_Path = App.Path & "\Database.txt"
End If

AddC frmMain.RTB2, RGB(6, 110, 158), "Database Path: ", QBColor(7), clsBotVars.NDB_Path
AddC frmMain.RTB2, RGB(6, 110, 158), "Loaded: ", QBColor(7), "Configurations."
End Sub

Public Sub Load_CDKeys()
On Error Resume Next
tCDKey.D2DV = UCase$(ReadINI("CDKeys", "D2DV", "Config.ini"))
tCDKey.D2XP = UCase$(ReadINI("CDKeys", "D2XP", "Config.ini"))
tCDKey.STAR = UCase$(ReadINI("CDKeys", "STAR", "Config.ini"))
tCDKey.W2BN = UCase$(ReadINI("CDKeys", "W2BN", "Config.ini"))
tCDKey.W3XP = UCase$(ReadINI("CDKeys", "W3XP", "Config.ini"))
tCDKey.WAR3 = UCase$(ReadINI("CDKeys", "WAR3", "Config.ini"))
AddC frmMain.RTB2, RGB(6, 110, 158), "Loaded: ", QBColor(7), "CDKeys."
End Sub

Private Sub Load_VerByte()
On Error Resume Next
VByte.STAR_V = ReadINI("VerByte", "STAR", "Config.ini")
VByte.D2DV_V = ReadINI("VerByte", "D2DV", "Config.ini")
VByte.W2BN_V = ReadINI("VerByte", "W2BN", "Config.ini")
VByte.WAR3_V = ReadINI("VerByte", "WAR3", "Config.ini")
AddC frmMain.RTB2, RGB(6, 110, 158), "Loaded: ", QBColor(7), "Version Byte Information."
End Sub

Private Sub Load_Settings()
On Error Resume Next
Settings.btGreetMode = ReadINI("Settings", "Greet_Mode", "Settings.ini")
If Settings.btGreetMode > 2 And Settings.btGreetMode < 1 Then Settings.btGreetMode = 1
Settings.strGreetMsg = ReadINI("Settings", "Greet_Msg", "Settings.ini")
Settings.intSVBanTick = (ReadINI("Settings", "Short_Visit_Tick", "Settings.ini") * 1000)
Settings.lngIdleBanTick = (ReadINI("Settings", "Idle_Ban_Tick", "Settings.ini") * 1000 * 60)
Settings.btIdleBanMode = ReadINI("Settings", "Idle_Ban_Mode", "Settings.ini")
If Settings.btIdleBanMode > 2 And Settings.btIdleBanMode < 1 Then Settings.btIdleBanMode = 1
Settings.intLimitBan = (ReadINI("Settings", "Limit_Ban_Number", "Settings.ini"))
Settings.intFRJB = (ReadINI("Settings", "Fast_Rejoin_Ban_Tick", "Settings.ini") * 1000)
Settings.intAutoCQ = (ReadINI("Settings", "Auto_Clear_Queue_Tick", "Settings.ini") * 1000)
AddC frmMain.RTB2, RGB(6, 110, 158), "Loaded: ", QBColor(7), "Settings."
End Sub

Private Sub Load_Options()
On Error Resume Next
Options.Greet = ReadINI("Options", "Greet", "Settings.ini")
Options.VictimCount = ReadINI("Options", "Victim_Count", "Settings.ini")
Options.AutoAddToggle = ReadINI("Options", "Auto_Realm", "Settings.ini")
Options.AutoDes = ReadINI("Options", "Auto_Designate", "Settings.ini")
Options.Idleban = ReadINI("Options", "Idle_Ban", "Settings.ini"): If Options.Idleban = True Then SetTimer frmMain.hwnd, 5, 10000, AddressOf TMR_IDLEBAN
Options.IgWhisper = ReadINI("Options", "Ignore_Whispers", "Settings.ini")
Options.IPBan = ReadINI("Options", "IP_Banning", "Settings.ini")
Options.KickOnYell = ReadINI("Options", "Kick_On_Yell", "Settings.ini")
Options.Lockdown = ReadINI("Options", "Lock_Down", "Settings.ini")
Options.Loud = ReadINI("Options", "Loud", "Settings.ini")
Options.Mimicban = ReadINI("Options", "Mimic_Ban", "Settings.ini")
Options.MLP = ReadINI("Options", "Massload_Protection", "Settings.ini")
Options.NullBMessages = ReadINI("Options", "Null_Ban_Messages", "Settings.ini")
Options.PhraseBan = ReadINI("Options", "Phrase_Bans", "Settings.ini")
Options.SmartBan = ReadINI("Options", "Smart_Ban", "Settings.ini")
Options.Spamban = ReadINI("Options", "Spam_Ban", "Settings.ini")
Options.SVBan = ReadINI("Options", "Short_Visit_Ban", "Settings.ini")
Options.LimitBan = ReadINI("Options", "Limit_Ban", "Settings.ini")
Options.ChanOptimize = ReadINI("Options", "Channel_Optimize", "Settings.ini")
Options.ColorBan = ReadINI("Options", "Color_Ban", "Settings.ini")
Options.FRJB = ReadINI("Options", "Fast_Rejoin_Ban", "Settings.ini")
Options.Prioritize_Queue = ReadINI("Options", "Prioritize_Queue", "Settings.ini")
Options.Auto_CQ = ReadINI("Options", "Auto_Clear_Queue", "Settings.ini")
Options.AutoCpriv = ReadINI("Options", "Auto_Clan_Private", "Settings.ini")
Options.Floodbot_Evasion = ReadINI("Options", "Flood_Bot_Evasion", "Settings.ini")
Options.Cmd_Log = ReadINI("Options", "Command_Logging", "Settings.ini")

If Options.Cmd_Log = True Then
    frmMain.mnuLOGCMDS.Checked = True
Else
    frmMain.mnuLOGCMDS.Checked = False
End If

If Options.Auto_CQ = True Then TMR_AUTOCLEARQUEUE

DBGMode = ReadINI("Options", "Debug_Mode", "Settings.ini")
AddC frmMain.RTB2, RGB(6, 110, 158), "Loaded: ", QBColor(7), "Options."
End Sub

Private Sub Load_Custom_Messages()
On Error Resume Next
    Messages.KickOnYell = ReadINI("Messages", "Kick_On_Yell", "Settings.ini")
    If Messages.KickOnYell = vbNullString Then Messages.KickOnYell = "Kick-On-Yell"
    Messages.Spamban = ReadINI("Messages", "Spam_Ban", "Settings.ini")
    If Messages.Spamban = vbNullString Then Messages.Spamban = "Spam-Ban"
    Messages.Lockdown = ReadINI("Messages", "Lock_Down", "Settings.ini")
    If Messages.Lockdown = vbNullString Then Messages.Lockdown = "Lockdown"
    Messages.MLP = ReadINI("Messages", "MLP", "Settings.ini")
    If Messages.MLP = vbNullString Then Messages.MLP = "Massload Protection"
    Messages.SweepBan = ReadINI("Messages", "Sweep_Ban", "Settings.ini")
    If Messages.SweepBan = vbNullString Then Messages.SweepBan = "SweepBan"
    Messages.QuietTime = ReadINI("Messages", "Quiet_Time", "Settings.ini")
    If Messages.QuietTime = vbNullString Then Messages.QuietTime = "Quiet-Time"
    Messages.ChanOptimize = ReadINI("Messages", "Channel_Optimize", "Settings.ini")
    If Messages.ChanOptimize = vbNullString Then Messages.ChanOptimize = "Channel Optimization"
    Messages.ColorBan = ReadINI("Messages", "Color_Ban", "Settings.ini")
    If Messages.ColorBan = vbNullString Then Messages.ColorBan = "Color-Ban"
    Messages.FRJB = ReadINI("Messages", "Fast_Rejoin_Ban", "Settings.ini")
    If Messages.FRJB = vbNullString Then Messages.FRJB = "FRJB"
    Messages.Flag_B = ReadINI("Messages", "Flag_B", "Settings.ini")
    If Messages.Flag_B = vbNullString Then Messages.Flag_B = "Auto-Ban: (B)"
    Messages.Flag_P = ReadINI("Messages", "Flag_P", "Settings.ini")
    If Messages.Flag_P = vbNullString Then Messages.Flag_P = "Auto-IPBan: (P)"
    Messages.Flag_K = ReadINI("Messages", "Flag_K", "Settings.ini")
    If Messages.Flag_K = vbNullString Then Messages.Flag_K = "Auto-Kick: (K)"
    AddC frmMain.RTB2, RGB(6, 110, 158), "Loaded: ", QBColor(7), "Ban messages."
End Sub

'---------------------------------------- Save

Public Sub Save_All()
On Error Resume Next

Open App.Path & "/Config.ini" For Output As #2
    Print #2, "## Support forums located at: http://www.zeroforce.net/" & vbNewLine
    Print #2, "[MAIN]"
    Print #2, "Username=" & clsBotVars.Username
    Print #2, "Password=" & clsBotVars.Password
    Print #2, "Server=" & clsBotVars.Server
    Print #2, "Home=" & clsBotVars.Channel
    Print #2, "Product=" & clsBotVars.Product
    Print #2, "DB_Path=" & clsBotVars.ODB_Path
    Print #2, "Trigger=" & clsBotVars.Trigger
    Print #2, "Email=" & clsBotVars.Email
    Print #2, "Spoof=" & clsBotVars.Spoof
    Print #2, "Plug=" & clsBotVars.Plug
    Print #2, vbNullString
    Print #2, "[PROXY]"
    Print #2, "Use=" & Proxy.Proxy_Use
    Print #2, "ProxyIP/Port=" & Proxy.Proxy_IP
    Print #2, vbNullString
    Print #2, "[BNLS]"
    Print #2, "Use=" & clsBotVars.BNLS_Use
    Print #2, "Server=" & clsBotVars.BNLS_Server
    Print #2, vbNullString
    Print #2, "[CDKeys]"
    Print #2, "STAR=" & tCDKey.STAR
    Print #2, "W2BN=" & tCDKey.W2BN
    Print #2, "D2DV=" & tCDKey.D2DV
    Print #2, "WAR3=" & tCDKey.WAR3
    Print #2, vbNullString
    Print #2, "[VERBYTE]"
    Print #2, "STAR=" & VByte.STAR_V
    Print #2, "D2DV=" & VByte.D2DV_V
    Print #2, "W2BN=" & VByte.W2BN_V
    Print #2, "WAR3=" & VByte.WAR3_V
Close #2

Save_Settings
Save_DB
Save_Quotes
Save_Phrases
AddC frmMain.RTB2, RGB(6, 110, 158), "Saved: ", QBColor(7), "Configuration, Settings, Database, and etc."
End Sub

Private Sub Save_Settings()
Close #1
Open App.Path & "/Settings.ini" For Output As #1
    Print #1, "## Support forums located at: http://www.zeroforce.net/" & vbNewLine
    Print #1, "[Options]"
    Print #1, "Auto_Realm=" & Options.AutoAddToggle
    Print #1, "Victim_Count=" & Options.VictimCount
    Print #1, "Null_Ban_Messages=" & Options.NullBMessages
    Print #1, "Smart_Ban=" & Options.SmartBan
    Print #1, "Auto_Designate=" & Options.AutoDes
    Print #1, "Ignore_Whispers=" & Options.IgWhisper
    Print #1, "Phrase_Bans=" & Options.PhraseBan
    Print #1, "Spam_Ban=" & Options.Spamban
    Print #1, "Idle_Ban=" & Options.Idleban
    Print #1, "Short_Visit_Ban=" & Options.SVBan
    Print #1, "Kick_On_Yell=" & Options.KickOnYell
    Print #1, "Mimic_Ban=" & Options.Mimicban
    Print #1, "Loud=" & Options.Loud
    Print #1, "Greet=" & Options.Greet
    Print #1, "IP_Banning=" & Options.IPBan
    Print #1, "Lock_Down=" & Options.Lockdown
    Print #1, "Massload_Protection=" & Options.MLP
    Print #1, "Limit_Ban=" & Options.LimitBan
    Print #1, "Channel_Optimize=" & Options.ChanOptimize
    Print #1, "Color_Ban=" & Options.ColorBan
    Print #1, "Fast_Rejoin_Ban=" & Options.FRJB
    Print #1, "Prioritize_Queue=" & Options.Prioritize_Queue
    Print #1, "Auto_Clear_Queue=" & Options.Auto_CQ
    Print #1, "Auto_Clan_Private=" & Options.AutoCpriv
    Print #1, "Flood_Bot_Evasion=" & Options.Floodbot_Evasion
    Print #1, "Command_Logging=" & Options.Cmd_Log
    Print #1, vbNullString
    Print #1, "Connect_On_Start=" & Options.Connect_On_Start
    Print #1, vbNullString
    Print #1, "[Settings]"
    Print #1, "// Units: Minutes (You can use decimal values. Ex: .25  = 15sec)"
    Print #1, "Idle_Ban_Tick=" & Settings.lngIdleBanTick
    Print #1, "Idle_Ban_Mode=" & Settings.btIdleBanMode
    Print #1, vbNullString
    Print #1, "// Units: Seconds"
    Print #1, "Short_Visit_Tick=" & Settings.intSVBanTick
    Print #1, "Fast_Rejoin_Ban_Tick=" & Settings.intFRJB
    Print #1, "Auto_Clear_Queue_Tick=" & Settings.intAutoCQ
    Print #1, vbNullString
    Print #1, "Greet_Mode=" & Settings.btGreetMode
    Print #1, "Greet_Msg=" & Settings.strGreetMsg
    Print #1, "Limit_Ban_Number=" & Settings.intLimitBan
    Print #1, vbNullString
    Print #1, "[Messages]"
    Print #1, "Flag_B=" & Messages.Flag_B
    Print #1, "Flag_P=" & Messages.Flag_P
    Print #1, "Flag_K=" & Messages.Flag_K
    Print #1, "Kick_On_Yell=" & Messages.KickOnYell
    Print #1, "Spam_Ban=" & Messages.Spamban
    Print #1, "Lock_Down=" & Messages.Lockdown
    Print #1, "MLP=" & Messages.MLP
    Print #1, "Sweep_Ban=" & Messages.SweepBan
    Print #1, "Quiet_Time=" & Messages.QuietTime
    Print #1, "Channel_Optimize=" & Messages.ChanOptimize
    Print #1, "Color_Ban=" & Messages.ColorBan
    Print #1, "Fast_Rejoin_Ban=" & Messages.FRJB
Close #1
End Sub

Private Sub Class_Initialize()
    Call TMR_GETNEWS 'News
End Sub

Private Sub Class_Terminate()
    Rest_Arrays
End Sub
