VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clse1Buffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Module    : clsBuffer (Packet Buffer Class Module)
' Date      : 7/14/04
' Author    : Trust[e1] (truste1@gmail.com)
'             http://www.clan-e1.net Op e1- @ USWest
' Purpose   : A packet buffer, based on DarkMinion[vL]'s.
' Code      : All code written by Trust[e1] unless otherwise stated.
' Thanks    : DarkMinion[vL], LoRd[nK], HoINer (Troubleshooting), Arta[vL] (BnetDocs)
'--------------------------------------------------------------------------------------

Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numBytes As Long)

Private Buffer As String

Public Enum Protocols  'Thanks to LoRd[nK] for the idea to add native support
    BOTNET             'for the protocols and to Arta's BnetDocs for the
    BNFTP              'protcol information.
    BNCS
    BNLS
    D2GS
    W3GS
    MCP
    UDP
End Enum

Public Enum Packets            'I have this because I like having the list when
    SID_NULL = &H0             'I call SendPacket(), and I don't see any speed
    SID_STOPADV = &H2          'issues with it.
    SID_SERVERLIST = &H4
    SID_CLIENTID = &H5
    SID_STARTVERSIONING = &H6
    SID_REPORTVERSION = &H7
    SID_GETADVLISTEX = &H9
    SID_ENTERCHAT = &HA
    SID_GETCHANNELLIST = &HB
    SID_JOINCHANNEL = &HC
    SID_CHATCOMMAND = &HE
    SID_CHATEVENT = &HF
    SID_LEAVECHAT = &H10
    SID_LOCALEINFO = &H12
    SID_FLOODDETECTED = &H13
    SID_UDPPINGRESPONSE = &H14
    SID_CHECKAD = &H15
    SID_CLICKAD = &H16
    SID_QUERYMEM = &H17
    SID_MESSAGEBOX = &H19
    SID_STARTADVEX2 = &H1A
    SID_GAMEDATAADDRESS = &H1B
    SID_STARTADVEX3 = &H1C
    SID_LOGONCHALLENGEEX = &H1D
    SID_CLIENTID2 = &H1E
    SID_BROADCAST = &H21
    SID_NOTIFYJOIN = &H22
    SID_SETCOOKIE = &H23
    SID_GETCOOKIE = &H24
    SID_PING = &H25
    SID_READUSERDATA = &H26
    SID_WRITEUSERDATA = &H27
    SID_LOGONCHALLENGE = &H28
    SID_LOGONRESPONSE = &H29
    SID_CREATEACCOUNT = &H2A
    SID_SYSTEMINFO = &H2B
    SID_GAMERESULT = &H2C
    SID_GETICONDATA = &H2D
    SID_GETLADDERDATA = &H2E
    SID_FINDLADDERUSER = &H2F
    SID_CDKEY = &H30
    SID_CHANGEPASSWORD = &H31
    SID_GETFILETIME = &H33
    SID_QUERYREALMS = &H34
    SID_CDKEY2 = &H36
    SID_LOGONRESPONSE2 = &H3A
    SID_CHECKDATAFILE2 = &H3C
    SID_CREATEACCOUNT2 = &H3D
    SID_LOGONREALMEX = &H3E
    SID_STARTVERSIONING2 = &H3F
    SID_QUERYREALMS2 = &H40
    SID_QUERYADURL = &H41
    SID_CDKEY3 = &H42
    SID_GAMING_PORT = &H45
    SID_NEWS_INFO = &H46
    SID_EXTRAWORK = &H4A
    SID_AUTH_INFO = &H50
    SID_AUTH_CHECK = &H51
    SID_AUTH_ACCOUNTCREATE = &H52
    SID_AUTH_ACCOUNTLOGON = &H53
    SID_AUTH_ACCOUNTLOGONPROOF = &H54
    SID_AUTH_ACCOUNTCHANGE = &H55
    SID_AUTH_AUTOCHANGEPROOF = &H56
    SID_AUTH_ACCOUNTUPGRADE = &H57
    SID_AUTH_ACCOUNTUPGRADEPROOF = &H58
    SID_SET_EMAIL = &H59
    SID_GET_NEW_PASS = &H5A
    SID_CHANGE_EMAIL = &H5B
    SID_W3GAME_INVITE = &H63
    SID_FRIENDLIST = &H65
    SID_FRIENDUPDATE = &H66
    SID_FRIENDADDED = &H67
    SID_FRIENDREMOVED = &H68
    SID_FRIENDMOVED = &H69
    SID_FINDCLANCANDIDATES = &H70
    SID_INVITEMULTIPLEUSERS = &H71
    SID_CLANINVITE = &H72
    SID_DISBANDCLAN = &H73
    SID_CLANINFO = &H75
    SID_INVITE_USER = &H77
    SID_CLAN_REMUSR = &H78
    SID_CLAN_EXIST_INVITE = &H79
    SID_CLAN_CHANGE_RANK = &H7A
    SID_CLAN_CHANGE_MOTD = &H7B
    SID_CLANMOTD = &H7C
    SID_CLAN_LIST = &H7D
    SID_CLAN_USER_REM = &H7E
    SID_CLAN_USER_UPDATE = &H7F
    SID_CLAN_PROMOTION = &H81
    
    'UDP
    
    PKT_SERVERPING = &H5
    PKT_KEEPALIVE = &H7
    PKT_CONNTEST2 = &H9
    
    'Realm
    
    MCP_STARTUP = &H1
    MCP_CHARCREATE = &H2
    MCP_CHARLOGON = &H7
    MCP_CHARDELETE = &HA
    MCP_MOTD = &H12
    MCP_CHARLIST = &H17
    MCP_CHARUPGRADE = &H18
    
    'Botnet
    
    PACKET_IDLE = &H0
    PACKET_LOGON = &H1
    PACKET_STATSUPDATE = &H2
    PACKET_DATABASE = &H3
    PACKET_MESSAGE = &H4
    PACKET_CYCLE = &H5
    PACKET_USERINFO = &H6
    PACKET_USERLOGGINGOFF = &H7
    PACKET_COMMAND = &H8
    PACKET_CHANGEDBPASSWORD = &H9
    PACKET_BOTNETVERSION = &HA
    PACKET_BOTNETCHAT = &HB
    PACKET_ACCOUNT = &HD
       
    'BNLS
    
    BNLS_NULL = &H0
    BNLS_CDKEY = &H1
    BNLS_LOGONCHALLENGE = &H2
    BNLS_LOGONPROOF = &H3
    BNLS_CREATEACCOUNT = &H4
    BNLS_CHANGECHALLENGE = &H5
    BNLS_CHANGEPROOF = &H6
    BNLS_UPGRADECHALLENGE = &H7
    BNLS_UPGRADEPROOF = &H8
    BNLS_VERSIONCHECK = &H9
    BNLS_CONFIRMLOGON = &HA
    BNLS_HASHDATA = &HB
    BNLS_CDKEY_EX = &HC
    BNLS_CHOOSENLSREVISION = &HD
    BNLS_AUTHORIZE = &HE
    BNLS_AUTHORIZEPROOF = &HF
    BNLS_REQUESTVERSIONBYTE = &H10
    BNLS_VERIFYSERVER = &H11
    BNLS_RESERVESERVERSLOTS = &H12
    BNLS_SERVERLOGONCHALLENGE = &H13
    BNLS_SERVERLOGONPROOF = &H14

End Enum

'---------------------------------------------------------------------------------------
' Procedure   : MakeDWORD
' Description : DWORD: An 32-bit unsigned integer in little endian byte order.
' Purpose     : Return a string DWORD from a long.
'---------------------------------------------------------------------------------------
Public Function MakeDWORD(lData As Long) As String
On Error GoTo ErrHndl
MakeDWORD = Space(4)

    Call CopyMemory(ByVal MakeDWORD, lData, 4)
    
ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - MakeDWORD"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : MakeWORD
' Description : WORD: 16-bit unsigned integer in little endian byte order.
' Purpose     : Return a WORD from a long.
'---------------------------------------------------------------------------------------
Public Function MakeWORD(iData As Integer) As String
On Error GoTo ErrHndl
MakeWORD = Space(2)

    Call CopyMemory(ByVal MakeWORD, iData, 2)
    
ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - MakeWORD"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : GetDWORD
' Purpose     : Gets a DWORD.
'---------------------------------------------------------------------------------------
Public Function GetDWORD(sData As String) As Long
On Error GoTo ErrHndl

    Call CopyMemory(GetDWORD, ByVal sData, 4)

ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - GetDWORD"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : GetWORD
' Purpose     : Gets a WORD.
'---------------------------------------------------------------------------------------
Public Function GetWORD(sData As String) As Long
On Error GoTo ErrHndl

    Call CopyMemory(GetWORD, ByVal sData, 2)

ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - GetWORD"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : InsertDWORD
' Description : DWORD = (String * 4 - 00 00 00 00)
' Purpose     : Add a DWORD to the buffer.
'---------------------------------------------------------------------------------------
Public Function InsertDWORD(lData As Long)
On Error GoTo ErrHndl
    
    Buffer = Buffer & MakeDWORD(lData)
    
ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - InsertDWORD"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : InsertWORD
' Description : WORD = (String * 2 - 00 00)
' Purpose     : Add a WORD to the buffer.
'---------------------------------------------------------------------------------------
Public Function InsertWORD(iData As Integer)
On Error GoTo ErrHndl

    Buffer = Buffer & MakeWORD(iData)

ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - InsertWORD"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : InsertBYTE
' Description : BYTE: 8-bit unsigned integer. (00)
' Purpose     : Add a BYTE to the buffer.
'---------------------------------------------------------------------------------------
Public Function InsertBYTE(iData As Integer)
On Error GoTo ErrHndl

    Buffer = Buffer & Chr(iData)

ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - InsertBYTE"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : InsertNonNTString
' Purpose     : Adds a non null terminated string to the buffer.
'---------------------------------------------------------------------------------------
Public Function InsertNonNTString(sData As String)
On Error GoTo ErrHndl

    Buffer = Buffer & sData
    
ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - InsertNonNTString"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : InsertNTString
' Purpose     : Adds a null terminated string to the buffer.
'---------------------------------------------------------------------------------------
Public Function InsertNTString(sData As String)
On Error GoTo ErrHndl

    Buffer = Buffer & sData & Chr(0)

ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - InsertNTString"
End Function

'---------------------------------------------------------------------------------------
' Procedure   : BuffClear
' Purpose     : Clears the buffer.
'---------------------------------------------------------------------------------------
Public Sub BuffClear()
    Buffer = vbNullString
End Sub
'---------------------------------------------------------------------------------------
' Procedure   : SendPacket
' Purpose     : Finishes building the packet, sends it to the respective protocol and
'               clears the buffer.
'---------------------------------------------------------------------------------------
Public Sub SendPacket(Protocol As Protocols, wSocket As Winsock, PacketID As Packets)
On Error GoTo ErrHndl

Select Case Protocol
    Case BNCS
        '(BYTE)      StartPacket - always 0xFF
        '(BYTE)      Packet ID
        '(WORD)      Packet length, including this header
        '(VOID)      Packet Data
        Call wSocket.SendData(Chr$(&HFF) & PacketID & MakeWORD(Len(Buffer) + 4) & Buffer)

    Case BNLS
        '(WORD)      Packet Length, including this header
        '(BYTE)      Packet ID
        '(VOID)      Packet Data
        Call wSocket.SendData(MakeWORD(Len(Buffer) + 3) & Chr$(PacketID) & Buffer)
    
    Case BOTNET
        '(BYTE)      Protocol Version (Currently 0x01)
        '(BYTE)      Packet ID
        '(WORD)      Packet Length, including this header
        '(VOID)      Packet Data
        Call wSocket.SendData(Chr$(&H1) & Chr$(PacketID) & MakeWORD(Len(Buffer) + 4) & Buffer)

    Case BNFTP
        '(WORD)      Packet length, including this header
        '(VOID)      Packet Data
        Call wSocket.SendData(MakeWORD(Len(Buffer) + 2) & Buffer)
        
    Case MCP
        '(WORD)      Packet length, including this header
        '(BYTE)      Packet ID
        '(VOID)      Packet Data
        Call wSocket.SendData(MakeWORD(Len(Buffer) + 3) & Chr$(PacketID) & Buffer)
        
    Case UDP
        'I don't know the header.
        Call wSocket.SendData(Buffer)
    Case D2GS
        '(BYTE)      Packet ID
        '(VOID)      Packet Data
        Call wSocket.SendData(Chr$(PacketID) & Buffer)

    Case W3GS
        '(BYTE)      StartPacket - always 0xF7
        '(BYTE)      Packet ID
        '(WORD)      Packet length, including this header
        '(VOID)      Packet Data
        Call wSocket.SendData(Chr$(&HF7) & Chr$(PacketID) & MakeWORD(Len(Buffer) + 4) & Buffer)
        
    Case Else
        '(VOID)      Packet Data
        Call wSocket.SendData(Buffer)
        
End Select
    
    Call BuffClear
    
ErrHndl:
    Debug.Print "Error [" & Err.Number & "] " & Err.Description & " - SendPacket"
End Sub
