Attribute VB_Name = "modNLS"
Option Explicit

' modNLS.bas created by Binary[xL] '

'*********'
' NLS/SRP '
'*********'

Declare Function Init Lib "NLS.dll" Alias "#1" () As Long

Declare Function Uninit Lib "NLS.dll" Alias "#2" () As Long

Declare Function AuthAccountLogon Lib "NLS.dll" Alias "#3" (ByVal strOutbuf As String) As Long

Declare Function AuthAccountLogonProof Lib "NLS.dll" Alias "#4" (ByVal strOutbuf As String, ByVal strUsername As String, ByVal strPassword As String, ByVal strSalt As String, ByVal strPubKey As String) As Long

Declare Function AuthAccountCreate Lib "NLS.dll" Alias "#5" (ByVal strHash As String, ByVal strUsername As String, ByVal strPassword As String) As Long

Private Declare Sub DecodeWar3CDkey Lib "NLS.dll" Alias "#8" (ByVal strCDKey As String, ByVal strPrivate As String, ByRef ptrValue1 As Long, ByRef ptrValue2 As Long)


'****************'
' Standard SHA-1 '
'****************'
Private Declare Sub SHA1Init Lib "StandardSHA1.dll" (ByVal ptrContext As Long)
Private Declare Sub SHA1Update Lib "StandardSHA1.dll" (ByVal ptrContext As Long, ByVal ptrData As Long, ByVal lngLen As Long)
Private Declare Sub SHA1Final Lib "StandardSHA1.dll" (ByVal ptrDigest As Long, ByVal ptrContext As Long)

Private Type SHA1_CTX
    lngState(4) As Long
    lngCount(1) As Long
    bytBuffer(63) As Byte
End Type

Private Const SHA_DIGESTSIZE As Byte = 20
Private Declare Sub RtlMoveMemory Lib "kernel32.dll" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function SHA1Add(ByVal ptrContext As Long, ByVal ptrData As Long, ByVal lngLen As Long) As Byte()
Dim bytDigest(SHA_DIGESTSIZE - 1) As Byte

    Call SHA1Init(ptrContext)

    Call SHA1Update(ptrContext, ptrData, lngLen)
    
    Call SHA1Final(VarPtr(bytDigest(0)), ptrContext)
    
    SHA1Add = bytDigest()

End Function

Public Sub DecodeHashCDKey(ByVal strCDKey As String, ByVal lngClientKey As Long, ByVal lngServerKey As Long, ByRef lngProdID As Long, ByRef lngValue1 As Long, ByRef strOutbuf As String)
Dim u1 As Long, u2 As String, u3 As Long
Dim bytHashBuffer(25) As Byte
Dim Context As SHA1_CTX
Dim bytHashedData() As Byte
Dim i As Byte
    
    ' u3 = ProdID '
    ' u2 = 10 Byte Buffer '
    ' u1 = Long '
    
    u2 = String$(10, vbNullChar)
    
    DecodeWar3CDkey UCase$(strCDKey), u2, u3, u1

    RtlMoveMemory ByVal VarPtr(bytHashBuffer(0)), lngClientKey, 4
    RtlMoveMemory ByVal VarPtr(bytHashBuffer(4)), lngServerKey, 4
    RtlMoveMemory ByVal VarPtr(bytHashBuffer(8)), u3, 4
    RtlMoveMemory ByVal VarPtr(bytHashBuffer(12)), u1, 4

    For i = 0 To 9
        RtlMoveMemory ByVal VarPtr(bytHashBuffer(16 + i)), CByte(Asc(Mid$(u2, i + 1, 1))), 1
    Next i
    
    bytHashedData() = SHA1Add(VarPtr(Context), VarPtr(bytHashBuffer(0)), UBound(bytHashBuffer) + 1)
    
    lngProdID = u3
    lngValue1 = u1
    strOutbuf = StrConv(bytHashedData, vbUnicode)
    
End Sub

Public Sub InitNLS()
    Call Init
End Sub

Public Sub UninitNLS()
    Call Uninit
End Sub

Public Function AccountLogon(strUsername As String) As String
Dim strReturn As String
    
    strReturn = String$(32, vbNullChar)
    
    Call AuthAccountLogon(strReturn)

    AccountLogon = strReturn
End Function

Public Function AccountLogonProof(strUsername As String, strPassword As String, strSalt As String, strPubKey As String) As String
Dim strReturn As String
    
    strReturn = String$(20, vbNullChar)
    
    Call AuthAccountLogonProof(strReturn, strUsername, strPassword, strSalt, strPubKey)
    
    AccountLogonProof = strReturn
End Function

Public Function AccountCreate(strUsername As String, strPassword As String) As String
Dim strReturn As String
    
    strReturn = String$(64, vbNullChar)
    
    Call AuthAccountCreate(strReturn, strUsername, strPassword)
    
    AccountCreate = strReturn
End Function
